# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables


class CatalogEntry(pulumi.CustomResource):
    address: pulumi.Output[str]
    """
    The address of the node being added to,
    or referenced in the catalog.
    """
    datacenter: pulumi.Output[str]
    """
    The datacenter to use. This overrides the
    agent's default datacenter and the datacenter in the provider setup.
    """
    node: pulumi.Output[str]
    """
    The name of the node being added to, or
    referenced in the catalog.
    """
    services: pulumi.Output[list]
    """
    A service to optionally associated with
    the node. Supported values are documented below.

      * `address` (`str`) - The address of the service. Defaults to the
        node address.
      * `id` (`str`) - The ID of the service. Defaults to the `name`.
      * `name` (`str`) - The name of the service
      * `port` (`float`) - The port of the service.
      * `tags` (`list`) - A list of values that are opaque to Consul,
        but can be used to distinguish between services or nodes.
    """
    token: pulumi.Output[str]
    """
    ACL token.
    """
    def __init__(__self__, resource_name, opts=None, address=None, datacenter=None, node=None, services=None, token=None, __props__=None, __name__=None, __opts__=None):
        """
        !> The `CatalogEntry` resource has been deprecated in version 2.0.0 of the provider
        and will be removed in a future release. Please read the [upgrade guide](https://www.terraform.io/docs/providers/consul/guides/upgrading.html#deprecation-of-consul_catalog_entry)
        for more information.

        Registers a node or service with the [Consul Catalog](https://www.consul.io/docs/agent/http/catalog.html#catalog_register).
        Currently, defining health checks is not supported.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_consul as consul

        app = consul.CatalogEntry("app",
            address="192.168.10.10",
            node="foobar",
            services=[{
                "address": "127.0.0.1",
                "id": "redis1",
                "name": "redis",
                "port": 8000,
                "tags": [
                    "master",
                    "v1",
                ],
            }])
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] address: The address of the node being added to,
               or referenced in the catalog.
        :param pulumi.Input[str] datacenter: The datacenter to use. This overrides the
               agent's default datacenter and the datacenter in the provider setup.
        :param pulumi.Input[str] node: The name of the node being added to, or
               referenced in the catalog.
        :param pulumi.Input[list] services: A service to optionally associated with
               the node. Supported values are documented below.
        :param pulumi.Input[str] token: ACL token.

        The **services** object supports the following:

          * `address` (`pulumi.Input[str]`) - The address of the service. Defaults to the
            node address.
          * `id` (`pulumi.Input[str]`) - The ID of the service. Defaults to the `name`.
          * `name` (`pulumi.Input[str]`) - The name of the service
          * `port` (`pulumi.Input[float]`) - The port of the service.
          * `tags` (`pulumi.Input[list]`) - A list of values that are opaque to Consul,
            but can be used to distinguish between services or nodes.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if address is None:
                raise TypeError("Missing required property 'address'")
            __props__['address'] = address
            __props__['datacenter'] = datacenter
            if node is None:
                raise TypeError("Missing required property 'node'")
            __props__['node'] = node
            __props__['services'] = services
            __props__['token'] = token
        super(CatalogEntry, __self__).__init__(
            'consul:index/catalogEntry:CatalogEntry',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, address=None, datacenter=None, node=None, services=None, token=None):
        """
        Get an existing CatalogEntry resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] address: The address of the node being added to,
               or referenced in the catalog.
        :param pulumi.Input[str] datacenter: The datacenter to use. This overrides the
               agent's default datacenter and the datacenter in the provider setup.
        :param pulumi.Input[str] node: The name of the node being added to, or
               referenced in the catalog.
        :param pulumi.Input[list] services: A service to optionally associated with
               the node. Supported values are documented below.
        :param pulumi.Input[str] token: ACL token.

        The **services** object supports the following:

          * `address` (`pulumi.Input[str]`) - The address of the service. Defaults to the
            node address.
          * `id` (`pulumi.Input[str]`) - The ID of the service. Defaults to the `name`.
          * `name` (`pulumi.Input[str]`) - The name of the service
          * `port` (`pulumi.Input[float]`) - The port of the service.
          * `tags` (`pulumi.Input[list]`) - A list of values that are opaque to Consul,
            but can be used to distinguish between services or nodes.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["address"] = address
        __props__["datacenter"] = datacenter
        __props__["node"] = node
        __props__["services"] = services
        __props__["token"] = token
        return CatalogEntry(resource_name, opts=opts, __props__=__props__)

    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop
