# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class GetServiceResult:
    """
    A collection of values returned by getService.
    """
    def __init__(__self__, datacenter=None, filter=None, id=None, name=None, query_options=None, services=None, tag=None):
        if datacenter and not isinstance(datacenter, str):
            raise TypeError("Expected argument 'datacenter' to be a str")
        __self__.datacenter = datacenter
        """
        The datacenter the keys are being read from to.
        """
        if filter and not isinstance(filter, str):
            raise TypeError("Expected argument 'filter' to be a str")
        __self__.filter = filter
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        __self__.id = id
        """
        The provider-assigned unique ID for this managed resource.
        """
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        __self__.name = name
        """
        The name of the service
        """
        if query_options and not isinstance(query_options, list):
            raise TypeError("Expected argument 'query_options' to be a list")
        __self__.query_options = query_options
        if services and not isinstance(services, list):
            raise TypeError("Expected argument 'services' to be a list")
        __self__.services = services
        """
        A list of nodes and details about each endpoint advertising a
        service.  Each element in the list is a map of attributes that correspond to
        each individual node.  The list of per-node attributes is detailed below.
        """
        if tag and not isinstance(tag, str):
            raise TypeError("Expected argument 'tag' to be a str")
        __self__.tag = tag
        """
        The name of the tag used to filter the list of nodes in `service`.
        """
class AwaitableGetServiceResult(GetServiceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetServiceResult(
            datacenter=self.datacenter,
            filter=self.filter,
            id=self.id,
            name=self.name,
            query_options=self.query_options,
            services=self.services,
            tag=self.tag)

def get_service(datacenter=None,filter=None,name=None,query_options=None,tag=None,opts=None):
    """
    `Service` provides details about a specific Consul service in a
    given datacenter.  The results include a list of nodes advertising the specified
    service, the node's IP address, port number, node ID, etc.  By specifying a
    different datacenter in the `query_options` it is possible to retrieve a list of
    services from a different WAN-attached Consul datacenter.

    This data source is different from the `getServices` (plural) data
    source, which provides a summary of the current Consul services.


    :param str datacenter: The Consul datacenter to query.  Defaults to the
           same value found in `query_options` parameter specified below, or if that is
           empty, the `datacenter` value found in the Consul agent that this provider is
           configured to talk to.
    :param str filter: A filter expression to refine the query, see https://www.consul.io/api-docs/features/filtering
           and https://www.consul.io/api-docs/catalog#filtering-1.
    :param str name: The service name to select.
    :param list query_options: See below.
    :param str tag: A single tag that can be used to filter the list of nodes
           to return based on a single matching tag..

    The **query_options** object supports the following:

      * `allowStale` (`bool`) - When `true`, the default, allow responses from
        Consul servers that are followers.
      * `datacenter` (`str`) - The Consul datacenter to query.  Defaults to the
        same value found in `query_options` parameter specified below, or if that is
        empty, the `datacenter` value found in the Consul agent that this provider is
        configured to talk to.
      * `namespace` (`str`) - The namespace to lookup the service.
      * `near` (`str`)
      * `node_meta` (`dict`)
      * `requireConsistent` (`bool`) - When `true` force the client to perform a
        read on at least quorum servers and verify the result is the same.  Defaults
        to `false`.
      * `token` (`str`) - Specify the Consul ACL token to use when performing the
        request.  This defaults to the same API token configured by the `consul`
        provider but may be overriden if necessary.
      * `waitIndex` (`float`) - Index number used to enable blocking quereis.
      * `waitTime` (`str`) - Max time the client should wait for a blocking query
        to return.
    """
    __args__ = dict()


    __args__['datacenter'] = datacenter
    __args__['filter'] = filter
    __args__['name'] = name
    __args__['queryOptions'] = query_options
    __args__['tag'] = tag
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = utilities.get_version()
    __ret__ = pulumi.runtime.invoke('consul:index/getService:getService', __args__, opts=opts).value

    return AwaitableGetServiceResult(
        datacenter=__ret__.get('datacenter'),
        filter=__ret__.get('filter'),
        id=__ret__.get('id'),
        name=__ret__.get('name'),
        query_options=__ret__.get('queryOptions'),
        services=__ret__.get('services'),
        tag=__ret__.get('tag'))
